"""
Django settings for medux_online project.

Generated by 'django-admin startproject' using Django 3.2.9.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path

import environ
from django.contrib import messages
from django.utils.translation import gettext_lazy as _
from gdaps.pluginmanager import PluginManager

env = environ.Env(DEBUG=(bool, False))


# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

PROJECT_TITLE = "MedUX Online"
PROJECT_NAME = "medux_online"
environ.Env.read_env(BASE_DIR / ".env")

DEBUG = env("DEBUG")

SECRET_KEY = env("SECRET_KEY")

ALLOWED_HOSTS = ["*"]
# FIXED: find a way to add dynamic host patterns (=subdomains) to ALLOWED_HOSTS
# if DEBUG:
#     ALLOWED_HOSTS += ["example.com", ".example.com", "example2.com", ".example2.com"]
if DEBUG:
    INTERNAL_IPS = ["127.0.0.1"]

# Application definition
INSTALLED_APPS = [
    "daphne",
    "channels",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django.contrib.sites",
    "extra_views",
    "crispy_forms",
    "crispy_bootstrap5",
    # "compressor",
    "polymorphic",
    "gdaps",
    "django_htmx",
    "colorfield",
    # fixed plugins:
    "medux.common",
    "medux.preferences",
    "medux_online.core",
    "medux_online.plugins.homepage",
    "medux_online.plugins.prescriptions",
]

if DEBUG:
    INSTALLED_APPS += [
        "django_extensions",
        "debug_toolbar",
    ]

# + dynamic Plugin apps, if any
INSTALLED_APPS += PluginManager.find_plugins("medux_online.plugins")

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.locale.LocaleMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "django.contrib.sites.middleware.CurrentSiteMiddleware",
    "medux_online.core.middleware.TenantMiddleware",
    "medux_online.core.middleware.HomepageMiddleware",
    "medux.common.middleware.HtmxMessageMiddleware",
    "django_htmx.middleware.HtmxMiddleware",
]
if DEBUG:
    MIDDLEWARE = ["debug_toolbar.middleware.DebugToolbarMiddleware"] + MIDDLEWARE

ROOT_URLCONF = "medux_online.urls"
ROOT_HOSTCONF = "medux_online.hosts"
DEFAULT_HOST = "root"
SITE_ID = 1

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "medux.preferences.context_processors.preferences",
                "medux.common.context_processors.globals",
            ],
        },
    },
]

# if DEBUG:
#     TEMPLATES[0]["OPTIONS"]["string_if_invalid"] = "{{ %s }}"

ASGI_APPLICATION = "medux_online.asgi.application"


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": env("DB_ENGINE"),
        "NAME": env("DB_NAME"),
        "PASSWORD": env("DB_PASSWORD", default=""),
    }
}

AUTH_USER_MODEL = "core.User"

# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]
PASSWORD_HASHERS = [
    "django.contrib.auth.hashers.Argon2PasswordHasher",
    "django.contrib.auth.hashers.PBKDF2PasswordHasher",
    "django.contrib.auth.hashers.PBKDF2SHA1PasswordHasher",
    "django.contrib.auth.hashers.BCryptSHA256PasswordHasher",
    "django.contrib.auth.hashers.ScryptPasswordHasher",
]

# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = "de"

TIME_ZONE = "Europe/Vienna"

USE_I18N = True

# DATETIME_FORMAT = 'Y-m-d H:M'

USE_TZ = True

LANGUAGES = [
    ("de", _("German")),
    ("en", _("English")),
]

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = "static/"

STATIC_ROOT = env("STATIC_ROOT", default=BASE_DIR / "static")

# STATICFILES_DIRS = [...]

# Django-Compressor settings
# STATICFILES_FINDERS = [
#     "django.contrib.staticfiles.finders.AppDirectoriesFinder",
#     "compressor.finders.CompressorFinder",
# ]
# COMPRESS_PRECOMPILERS = (("text/x-scss", "django_libsass.SassCompiler"),)
# COMPRESS_ROOT = STATIC_ROOT

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

CRISPY_ALLOWED_TEMPLATE_PACKS = "bootstrap5"
CRISPY_TEMPLATE_PACK = "bootstrap5"
CRISPY_FAIL_SILENTLY = not DEBUG

LOGGING = {
    "version": 1,
    "disable_existing_loggers": False,
    "handlers": {
        "console": {
            "class": "logging.StreamHandler",
        },
    },
    "root": {
        "handlers": ["console"],
        "level": "INFO",
    },
    "loggers": {
        "django": {
            "handlers": ["console"],
            "level": "INFO",
            "propagate": False,
        },
    },
}


MEDIA_ROOT = env("MEDIA_ROOT")
MEDIA_URL = "/media/"


# CHANNEL_LAYERS = {
#     # You will need to `pip install channels_redis` and configure a redis instance.
#     # Using InMemoryChannelLayer will not work as the stored memory is not shared between threads.
#     # See https://channels.readthedocs.io/en/latest/topics/channel_layers.html
#     "default": {
#         "BACKEND": "channels_redis.core.RedisChannelLayer",
#         "CONFIG": {
#             "hosts": [("127.0.0.1", 6379)],
#             # "hosts": ["redis://:password@127.0.0.1:6379/0"],
#             # "symmetric_encryption_keys": [SECRET_KEY],
#         },
#     },
# }

FIXTURE_DIRS = [BASE_DIR / "medux_online" / "fixtures"]

# message tags for bootstrap5
MESSAGE_TAGS = {
    messages.SUCCESS: "text-white bg-success",
    messages.DEBUG: "bg-light",
    messages.INFO: "text-white bg-primary",
    messages.WARNING: "text-dark bg-warning",
    messages.ERROR: "text-white bg-danger",
}
LOGIN_REDIRECT_URL = "/dashboard"
LOGOUT_REDIRECT_URL = "/"

# if DEBUG:
#     CHANNEL_LAYERS = {
#         "default": {
#             "BACKEND": "channels.layers.InMemoryChannelLayer",
#         },
#     }
# else:
if True:
    REDIS_URL = env("REDIS_URL", default=("127.0.0.1", 6379))
    CHANNEL_LAYERS = {
        "default": {
            "BACKEND": "channels_redis.core.RedisChannelLayer",
            "CONFIG": {
                "hosts": [REDIS_URL],
            },
        },
    }
